/*
** Machine-generated from xpow.h. Tue Jul 10 12:46:19 CDT 2001
** Edit at your own risk.  Copyright (c) K2 Tech, L.L.C
*/
#include "xpow.h" 
 
int _XPPackHeader(xp_ray_header_t *head, unsigned char *buff)
{
   /* Machine-generated routine for packing XPOW structure. */

   unsigned int bp = 0;
   int i;
   union {
      float ftmp;
      int   itmp;
   } var;

   /* char magic */  /* Magic string. First 4: "XPOW", rest \0 */

   memcpy(&buff[bp],head->magic,10);
   bp = bp + 10;

   /* int nheader_lines */  /* Number of lines in this header */

   var.itmp = head->nheader_lines;
   buff[bp++] = XP_GETBYTE(0,var.itmp);
   buff[bp++] = XP_GETBYTE(1,var.itmp);

   /* float version */  /* Version of the XPOW format */

   var.ftmp = head->version;
   buff[bp++] = XP_GETBYTE(0,var.itmp);
   buff[bp++] = XP_GETBYTE(1,var.itmp);
   buff[bp++] = XP_GETBYTE(2,var.itmp);
   buff[bp++] = XP_GETBYTE(3,var.itmp);

   /* int encoding */  /* XP_BINARY_ENC, XP_ASCII_ENC, XP_SIMPLE_ENC */

   var.itmp = head->encoding;
   buff[bp++] = XP_GETBYTE(0,var.itmp);
   buff[bp++] = XP_GETBYTE(1,var.itmp);

   /* int year */  /* 2000, 2001, ... */

   var.itmp = head->year;
   buff[bp++] = XP_GETBYTE(0,var.itmp);
   buff[bp++] = XP_GETBYTE(1,var.itmp);

   /* int month */  /* Jan = 1, Dec = 12 */

   var.itmp = head->month;
   buff[bp++] = XP_GETBYTE(0,var.itmp);
   buff[bp++] = XP_GETBYTE(1,var.itmp);

   /* int day */  /* 0...31 */

   var.itmp = head->day;
   buff[bp++] = XP_GETBYTE(0,var.itmp);
   buff[bp++] = XP_GETBYTE(1,var.itmp);

   /* int hour */  /* 0...23 */

   var.itmp = head->hour;
   buff[bp++] = XP_GETBYTE(0,var.itmp);
   buff[bp++] = XP_GETBYTE(1,var.itmp);

   /* int minute */  /* 0...59 */

   var.itmp = head->minute;
   buff[bp++] = XP_GETBYTE(0,var.itmp);
   buff[bp++] = XP_GETBYTE(1,var.itmp);

   /* float second */  /* 0...59.0 (Note 2) */

   var.ftmp = head->second;
   buff[bp++] = XP_GETBYTE(0,var.itmp);
   buff[bp++] = XP_GETBYTE(1,var.itmp);
   buff[bp++] = XP_GETBYTE(2,var.itmp);
   buff[bp++] = XP_GETBYTE(3,var.itmp);

   /* int nrays */  /* Number of rays in this sweep */

   var.itmp = head->nrays;
   buff[bp++] = XP_GETBYTE(0,var.itmp);
   buff[bp++] = XP_GETBYTE(1,var.itmp);

   /* int ray_number */  /* 0,1,..nrays-1 */

   var.itmp = head->ray_number;
   buff[bp++] = XP_GETBYTE(0,var.itmp);
   buff[bp++] = XP_GETBYTE(1,var.itmp);

   /* int ngates */  /* Number of gates in the dwell/ray */

   var.itmp = head->ngates;
   buff[bp++] = XP_GETBYTE(0,var.itmp);
   buff[bp++] = XP_GETBYTE(1,var.itmp);

   /* float azimuth */  /* Azimuth (degrees) for this dwell/ray */

   var.ftmp = head->azimuth;
   buff[bp++] = XP_GETBYTE(0,var.itmp);
   buff[bp++] = XP_GETBYTE(1,var.itmp);
   buff[bp++] = XP_GETBYTE(2,var.itmp);
   buff[bp++] = XP_GETBYTE(3,var.itmp);

   /* float elevation */  /* Elevation angle (degrees) for this dwell/ray */

   var.ftmp = head->elevation;
   buff[bp++] = XP_GETBYTE(0,var.itmp);
   buff[bp++] = XP_GETBYTE(1,var.itmp);
   buff[bp++] = XP_GETBYTE(2,var.itmp);
   buff[bp++] = XP_GETBYTE(3,var.itmp);

   /* int transition */  /* 1 => in transition from PPI->RHI, etc */

   var.itmp = head->transition;
   buff[bp++] = XP_GETBYTE(0,var.itmp);
   buff[bp++] = XP_GETBYTE(1,var.itmp);

   /* int nhits */  /* Number of hits */

   var.itmp = head->nhits;
   buff[bp++] = XP_GETBYTE(0,var.itmp);
   buff[bp++] = XP_GETBYTE(1,var.itmp);

   /* float tpulse */  /* Transmitter pulse width (s) */

   var.ftmp = head->tpulse;
   buff[bp++] = XP_GETBYTE(0,var.itmp);
   buff[bp++] = XP_GETBYTE(1,var.itmp);
   buff[bp++] = XP_GETBYTE(2,var.itmp);
   buff[bp++] = XP_GETBYTE(3,var.itmp);

   /* float rpulse */  /* Receiver pulse width (s) */

   var.ftmp = head->rpulse;
   buff[bp++] = XP_GETBYTE(0,var.itmp);
   buff[bp++] = XP_GETBYTE(1,var.itmp);
   buff[bp++] = XP_GETBYTE(2,var.itmp);
   buff[bp++] = XP_GETBYTE(3,var.itmp);

   /* float prt */  /* Pulse repetition time (s) */

   var.ftmp = head->prt;
   buff[bp++] = XP_GETBYTE(0,var.itmp);
   buff[bp++] = XP_GETBYTE(1,var.itmp);
   buff[bp++] = XP_GETBYTE(2,var.itmp);
   buff[bp++] = XP_GETBYTE(3,var.itmp);

   /* float latitude */  /* Radar latitute (from on-board GPS) */

   var.ftmp = head->latitude;
   buff[bp++] = XP_GETBYTE(0,var.itmp);
   buff[bp++] = XP_GETBYTE(1,var.itmp);
   buff[bp++] = XP_GETBYTE(2,var.itmp);
   buff[bp++] = XP_GETBYTE(3,var.itmp);

   /* float longitude */  /* Radar longitude (from on-board GPS) */

   var.ftmp = head->longitude;
   buff[bp++] = XP_GETBYTE(0,var.itmp);
   buff[bp++] = XP_GETBYTE(1,var.itmp);
   buff[bp++] = XP_GETBYTE(2,var.itmp);
   buff[bp++] = XP_GETBYTE(3,var.itmp);

   /* int scan_number */  /* Meaning unclear (Note 3) */

   var.itmp = head->scan_number;
   buff[bp++] = XP_GETBYTE(0,var.itmp);
   buff[bp++] = XP_GETBYTE(1,var.itmp);

   /* int volume_number */  /* Meaning unclear (Note 3)*/

   var.itmp = head->volume_number;
   buff[bp++] = XP_GETBYTE(0,var.itmp);
   buff[bp++] = XP_GETBYTE(1,var.itmp);

   /* int field_type */  /* Field code, i.e., XP_NCP (see above) */

   var.itmp = head->field_type;
   buff[bp++] = XP_GETBYTE(0,var.itmp);
   buff[bp++] = XP_GETBYTE(1,var.itmp);

   /* char field_name */  /* ASCII equivalent, i.e., "hdbz", "vel" */

   memcpy(&buff[bp],head->field_name,10);
   bp = bp + 10;

   /* int nthfields */  /* Number of fields used for thresholding <= 4 */

   var.itmp = head->nthfields;
   buff[bp++] = XP_GETBYTE(0,var.itmp);
   buff[bp++] = XP_GETBYTE(1,var.itmp);

   /* int thfield */  /* Threshold field: XP_NCP, XP_HDBZ, XP_NONE */

   for (i=0;i<=4-1;i++){
      var.itmp = head->thfield[i];
      buff[bp++] = XP_GETBYTE(0,var.itmp);
      buff[bp++] = XP_GETBYTE(1,var.itmp);
   }

   /* float thvalue */  /* Value that was used for threshold */

   for (i=0;i<=4-1;i++){
      var.ftmp = head->thvalue[i];
      buff[bp++] = XP_GETBYTE(0,var.itmp);
      buff[bp++] = XP_GETBYTE(1,var.itmp);
      buff[bp++] = XP_GETBYTE(2,var.itmp);
      buff[bp++] = XP_GETBYTE(3,var.itmp);
   }

   /* int scan_type */  /* One of: RHI, PPI, ,,, see #defines above */

   var.itmp = head->scan_type;
   buff[bp++] = XP_GETBYTE(0,var.itmp);
   buff[bp++] = XP_GETBYTE(1,var.itmp);

   /* long error_number */  /* For future expansion */

   var.itmp = head->error_number;
   buff[bp++] = XP_GETBYTE(0,var.itmp);
   buff[bp++] = XP_GETBYTE(1,var.itmp);
   buff[bp++] = XP_GETBYTE(2,var.itmp);
   buff[bp++] = XP_GETBYTE(3,var.itmp);

   /* long warning_number */  /* For future expansion */

   var.itmp = head->warning_number;
   buff[bp++] = XP_GETBYTE(0,var.itmp);
   buff[bp++] = XP_GETBYTE(1,var.itmp);
   buff[bp++] = XP_GETBYTE(2,var.itmp);
   buff[bp++] = XP_GETBYTE(3,var.itmp);

   /* int reserved */  /* For future expansion */

   for (i=0;i<=16-1;i++){
      var.itmp = head->reserved[i];
      buff[bp++] = XP_GETBYTE(0,var.itmp);
      buff[bp++] = XP_GETBYTE(1,var.itmp);
   }

   return(bp);
}

int _XPGetCodedHeaderSize(void)
{
   return(154);
}

int _XPUnPackHeader(xp_ray_header_t *head, unsigned char *buff)
{
   /* Machine-generated routine for unpacking XPOW structure. */

   unsigned int bp = 0;
   int i;
   union {
      float ftmp;
      int   itmp;
   } var;

   /* char magic */    /* Magic string. First 4: "XPOW", rest \0 */

   memcpy(head->magic,&buff[bp],10);
   bp = bp + 10;

   /* int nheader_lines */    /* Number of lines in this header */

   var.itmp = 0;
   var.itmp |= ((buff[bp++] & 0377) << 0*8);
   var.itmp |= ((buff[bp++] & 0377) << 1*8);
   head->nheader_lines = var.itmp;

   /* float version */    /* Version of the XPOW format */

   var.itmp = 0;
   var.itmp |= ((buff[bp++] & 0377) << 0*8);
   var.itmp |= ((buff[bp++] & 0377) << 1*8);
   var.itmp |= ((buff[bp++] & 0377) << 2*8);
   var.itmp |= ((buff[bp++] & 0377) << 3*8);
   head->version = var.ftmp;

   /* int encoding */    /* XP_BINARY_ENC, XP_ASCII_ENC, XP_SIMPLE_ENC */

   var.itmp = 0;
   var.itmp |= ((buff[bp++] & 0377) << 0*8);
   var.itmp |= ((buff[bp++] & 0377) << 1*8);
   head->encoding = var.itmp;

   /* int year */    /* 2000, 2001, ... */

   var.itmp = 0;
   var.itmp |= ((buff[bp++] & 0377) << 0*8);
   var.itmp |= ((buff[bp++] & 0377) << 1*8);
   head->year = var.itmp;

   /* int month */    /* Jan = 1, Dec = 12 */

   var.itmp = 0;
   var.itmp |= ((buff[bp++] & 0377) << 0*8);
   var.itmp |= ((buff[bp++] & 0377) << 1*8);
   head->month = var.itmp;

   /* int day */    /* 0...31 */

   var.itmp = 0;
   var.itmp |= ((buff[bp++] & 0377) << 0*8);
   var.itmp |= ((buff[bp++] & 0377) << 1*8);
   head->day = var.itmp;

   /* int hour */    /* 0...23 */

   var.itmp = 0;
   var.itmp |= ((buff[bp++] & 0377) << 0*8);
   var.itmp |= ((buff[bp++] & 0377) << 1*8);
   head->hour = var.itmp;

   /* int minute */    /* 0...59 */

   var.itmp = 0;
   var.itmp |= ((buff[bp++] & 0377) << 0*8);
   var.itmp |= ((buff[bp++] & 0377) << 1*8);
   head->minute = var.itmp;

   /* float second */    /* 0...59.0 (Note 2) */

   var.itmp = 0;
   var.itmp |= ((buff[bp++] & 0377) << 0*8);
   var.itmp |= ((buff[bp++] & 0377) << 1*8);
   var.itmp |= ((buff[bp++] & 0377) << 2*8);
   var.itmp |= ((buff[bp++] & 0377) << 3*8);
   head->second = var.ftmp;

   /* int nrays */    /* Number of rays in this sweep */

   var.itmp = 0;
   var.itmp |= ((buff[bp++] & 0377) << 0*8);
   var.itmp |= ((buff[bp++] & 0377) << 1*8);
   head->nrays = var.itmp;

   /* int ray_number */    /* 0,1,..nrays-1 */

   var.itmp = 0;
   var.itmp |= ((buff[bp++] & 0377) << 0*8);
   var.itmp |= ((buff[bp++] & 0377) << 1*8);
   head->ray_number = var.itmp;

   /* int ngates */    /* Number of gates in the dwell/ray */

   var.itmp = 0;
   var.itmp |= ((buff[bp++] & 0377) << 0*8);
   var.itmp |= ((buff[bp++] & 0377) << 1*8);
   head->ngates = var.itmp;

   /* float azimuth */    /* Azimuth (degrees) for this dwell/ray */

   var.itmp = 0;
   var.itmp |= ((buff[bp++] & 0377) << 0*8);
   var.itmp |= ((buff[bp++] & 0377) << 1*8);
   var.itmp |= ((buff[bp++] & 0377) << 2*8);
   var.itmp |= ((buff[bp++] & 0377) << 3*8);
   head->azimuth = var.ftmp;

   /* float elevation */    /* Elevation angle (degrees) for this dwell/ray */

   var.itmp = 0;
   var.itmp |= ((buff[bp++] & 0377) << 0*8);
   var.itmp |= ((buff[bp++] & 0377) << 1*8);
   var.itmp |= ((buff[bp++] & 0377) << 2*8);
   var.itmp |= ((buff[bp++] & 0377) << 3*8);
   head->elevation = var.ftmp;

   /* int transition */    /* 1 => in transition from PPI->RHI, etc */

   var.itmp = 0;
   var.itmp |= ((buff[bp++] & 0377) << 0*8);
   var.itmp |= ((buff[bp++] & 0377) << 1*8);
   head->transition = var.itmp;

   /* int nhits */    /* Number of hits */

   var.itmp = 0;
   var.itmp |= ((buff[bp++] & 0377) << 0*8);
   var.itmp |= ((buff[bp++] & 0377) << 1*8);
   head->nhits = var.itmp;

   /* float tpulse */    /* Transmitter pulse width (s) */

   var.itmp = 0;
   var.itmp |= ((buff[bp++] & 0377) << 0*8);
   var.itmp |= ((buff[bp++] & 0377) << 1*8);
   var.itmp |= ((buff[bp++] & 0377) << 2*8);
   var.itmp |= ((buff[bp++] & 0377) << 3*8);
   head->tpulse = var.ftmp;

   /* float rpulse */    /* Receiver pulse width (s) */

   var.itmp = 0;
   var.itmp |= ((buff[bp++] & 0377) << 0*8);
   var.itmp |= ((buff[bp++] & 0377) << 1*8);
   var.itmp |= ((buff[bp++] & 0377) << 2*8);
   var.itmp |= ((buff[bp++] & 0377) << 3*8);
   head->rpulse = var.ftmp;

   /* float prt */    /* Pulse repetition time (s) */

   var.itmp = 0;
   var.itmp |= ((buff[bp++] & 0377) << 0*8);
   var.itmp |= ((buff[bp++] & 0377) << 1*8);
   var.itmp |= ((buff[bp++] & 0377) << 2*8);
   var.itmp |= ((buff[bp++] & 0377) << 3*8);
   head->prt = var.ftmp;

   /* float latitude */    /* Radar latitute (from on-board GPS) */

   var.itmp = 0;
   var.itmp |= ((buff[bp++] & 0377) << 0*8);
   var.itmp |= ((buff[bp++] & 0377) << 1*8);
   var.itmp |= ((buff[bp++] & 0377) << 2*8);
   var.itmp |= ((buff[bp++] & 0377) << 3*8);
   head->latitude = var.ftmp;

   /* float longitude */    /* Radar longitude (from on-board GPS) */

   var.itmp = 0;
   var.itmp |= ((buff[bp++] & 0377) << 0*8);
   var.itmp |= ((buff[bp++] & 0377) << 1*8);
   var.itmp |= ((buff[bp++] & 0377) << 2*8);
   var.itmp |= ((buff[bp++] & 0377) << 3*8);
   head->longitude = var.ftmp;

   /* int scan_number */    /* Meaning unclear (Note 3) */

   var.itmp = 0;
   var.itmp |= ((buff[bp++] & 0377) << 0*8);
   var.itmp |= ((buff[bp++] & 0377) << 1*8);
   head->scan_number = var.itmp;

   /* int volume_number */    /* Meaning unclear (Note 3)*/

   var.itmp = 0;
   var.itmp |= ((buff[bp++] & 0377) << 0*8);
   var.itmp |= ((buff[bp++] & 0377) << 1*8);
   head->volume_number = var.itmp;

   /* int field_type */    /* Field code, i.e., XP_NCP (see above) */

   var.itmp = 0;
   var.itmp |= ((buff[bp++] & 0377) << 0*8);
   var.itmp |= ((buff[bp++] & 0377) << 1*8);
   head->field_type = var.itmp;

   /* char field_name */    /* ASCII equivalent, i.e., "hdbz", "vel" */

   memcpy(head->field_name,&buff[bp],10);
   bp = bp + 10;

   /* int nthfields */    /* Number of fields used for thresholding <= 4 */

   var.itmp = 0;
   var.itmp |= ((buff[bp++] & 0377) << 0*8);
   var.itmp |= ((buff[bp++] & 0377) << 1*8);
   head->nthfields = var.itmp;

   /* int thfield */    /* Threshold field: XP_NCP, XP_HDBZ, XP_NONE */

   for (i=0;i<=4-1;i++){
      var.itmp = 0;
      var.itmp |= ((buff[bp++] & 0377) << 0*8);
      var.itmp |= ((buff[bp++] & 0377) << 1*8);
      head->thfield[i] = var.itmp;
   }

   /* float thvalue */    /* Value that was used for threshold */

   for (i=0;i<=4-1;i++){
      var.itmp = 0;
      var.itmp |= ((buff[bp++] & 0377) << 0*8);
      var.itmp |= ((buff[bp++] & 0377) << 1*8);
      var.itmp |= ((buff[bp++] & 0377) << 2*8);
      var.itmp |= ((buff[bp++] & 0377) << 3*8);
      head->thvalue[i] = var.ftmp;
   }

   /* int scan_type */    /* One of: RHI, PPI, ,,, see #defines above */

   var.itmp = 0;
   var.itmp |= ((buff[bp++] & 0377) << 0*8);
   var.itmp |= ((buff[bp++] & 0377) << 1*8);
   head->scan_type = var.itmp;

   /* long error_number */    /* For future expansion */

   var.itmp = 0;
   var.itmp |= ((buff[bp++] & 0377) << 0*8);
   var.itmp |= ((buff[bp++] & 0377) << 1*8);
   var.itmp |= ((buff[bp++] & 0377) << 2*8);
   var.itmp |= ((buff[bp++] & 0377) << 3*8);
   head->error_number = var.itmp;

   /* long warning_number */    /* For future expansion */

   var.itmp = 0;
   var.itmp |= ((buff[bp++] & 0377) << 0*8);
   var.itmp |= ((buff[bp++] & 0377) << 1*8);
   var.itmp |= ((buff[bp++] & 0377) << 2*8);
   var.itmp |= ((buff[bp++] & 0377) << 3*8);
   head->warning_number = var.itmp;

   /* int reserved */    /* For future expansion */

   for (i=0;i<=16-1;i++){
      var.itmp = 0;
      var.itmp |= ((buff[bp++] & 0377) << 0*8);
      var.itmp |= ((buff[bp++] & 0377) << 1*8);
      head->reserved[i] = var.itmp;
   }

   return(bp);
}
